package jp.marunomaruno.judeapi2cpp.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

import jp.marunomaruno.judeapi2cpp.JudeApi2CppProperty;

/**
 * JudeAPÎJudet@CIt@C`[U[łB
 * ́ACt[́uQƁv{^NbN邱ƂŋN܂B
 * Judet@C̃pX́AeLXgtB[h̒lƂĐݒ肳܂B
 * 
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
public class SourceFileChooser implements ActionListener {
	private JTextField field;
	private File file;
	
	/**
	 * eLXgtB[hw肵āÃ\[Xt@C`[U[̃CX^X𐶐RXgN^[łB
	 * @param field eLXgtB[h
	 */
	public SourceFileChooser(JTextField field) {
		this.field = field;
		file = null;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		JFileChooser chooser = new JFileChooser(field.getText());
		chooser.addChoosableFileFilter(new FileFilter() {  
				public boolean accept(File file) {    
					if(file.isDirectory()) return true;    
					return file.getName().toLowerCase().endsWith(".jude");  
				}  
				public String getDescription() {    
					return "JUDEt@C(*.jude)";  
				}
			});
		int result = chooser.showOpenDialog( null );

		if(result == JFileChooser.APPROVE_OPTION) {
			file = chooser.getSelectedFile();
			JudeApi2CppProperty.getInstance().setSourceFile(file.getPath());
			System.out.println( "selected " + file.getPath() );
			field.setText(file.getPath());
		}
	}

}
