package jp.marunomaruno.judeapi2cpp.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import jp.marunomaruno.judeapi2cpp.JudeApi2Cpp;
import jp.marunomaruno.judeapi2cpp.JudeApi2CppProperty;
import jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil;

import com.change_vision.jude.api.inf.exception.ProjectLockedException;

/**
 * Judẽ\[Xt@Cƕϊ̃t@CfBNg[w肵āAJude API CPPt@CɕϊANVXi[łB
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
public class TransformCommand implements ActionListener {

	private JTextField source;
	private JTextField destination;
	private JTextField target;
	private JCheckBox forceReplaceFile;
	private JCheckBox setterCheckBox;
	private JCheckBox getterCheckBox;

	/**
	 * \[Xt@Cw肵ĂeLXgtB[hƕϊ̃t@CfBNg[w肵ĂeLXgtB[hƂɁÃCX^X𐶐RXgN^[łB
	 * @param source Judẽ\[Xt@Cw肵ĂeLXgtB[h
	 * @param destination ϊ̃t@CfBNg[w肵ĂeLXgtB[h
	 * @param target svOw肵ĂeLXgtB[h
	 * @param forceReplaceFile ϊ̃t@CfBNg[ɂt@C폜邩ǂ`FbN{bNX
	 */
	public TransformCommand(JTextField source, JTextField destination, JTextField target, JCheckBox forceReplaceFile, JCheckBox setterCheckBox, JCheckBox getterCheckBox) {
		this.source = source;
		this.destination = destination;
		this.target = target;
		this.forceReplaceFile = forceReplaceFile;
		this.setterCheckBox = setterCheckBox;
		this.getterCheckBox = getterCheckBox;
	}

	/* (non-Javadoc)
	 * JudeApi2Cpp.execute \bhĂяo܂B
	 * ϊAŎgt@CfBNg[vpeBt@Cɕۊǂ܂B
	 * @see jp.marunomaruno.judeapi2cpp.JudeApi2Cpp#execute(java.lang.String, java.lang.String)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		try {
			// ĐfBNg[̃N[
			if (forceReplaceFile.isSelected()) {
				JudeApi2CppUtil.deleteFiles(new File(destination.getText()));
			}
			
			// vpeB̐ݒ
			JudeApi2CppProperty.getInstance().setSourceFile(source.getText());
			JudeApi2CppProperty.getInstance().setDestinationDirectory(destination.getText());
			JudeApi2CppProperty.getInstance().setTarget(target.getText());
			JudeApi2CppProperty.getInstance().setForceReplaceFile(forceReplaceFile.isSelected());
			JudeApi2CppProperty.getInstance().setCreateSetter(setterCheckBox.isSelected());
			JudeApi2CppProperty.getInstance().setCreateGetter(getterCheckBox.isSelected());
			
			// ϊ
			new JudeApi2Cpp().execute(new File(source.getText()), new File(destination.getText()), target.getText());
			JOptionPane.showMessageDialog(null, "ϊI܂B");

			// vpeB̕ۑ
			JudeApi2CppProperty.getInstance().storeProperties();

			// Vbg_ÊƂÂ܂܏I
			if (JudeApi2CppProperty.getInstance().isAutoShutdown()) {
				System.exit(0);
			}
			
		} catch (ProjectLockedException e1) {
			e1.printStackTrace();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

}
